
class Pool
{
	////////////////////////////////////////////////////////////
	// Gobal pool API
	////////////////////////////////////////////////////////////

	static uint32 GetCount() { return mGobalPool.size(); } 
	/*------------------------------------------------------
	 * Pre  :  
	 * Post : Returns number of meshes in gobal store
	 ------------------------------------------------------*/

	static Mesh *GetMesh(index_t uid) 
	{ return (uid < mGobalPool.size()) ? mGobalPool[uid] : NULL; }
	/*------------------------------------------------------
	 * Pre  :  
	 * Post : Returns mesh matching gobal store UID
	 ------------------------------------------------------*/

	static void ResetPool() { mGobalPool.erase(); }
	/*------------------------------------------------------
	 * Pre  :  
	 * Post : Erase the gobal mesh store
	 ------------------------------------------------------*/

	index_t AddToPool();
	/*------------------------------------------------------
	 * Pre  :  
	 * Post : Add this mesh to the gobal store
	 *        Return UID
	 ------------------------------------------------------*/

	index_t GetUID() { return mUID; }
	/*------------------------------------------------------
	 * Pre  :  
	 * Post : Returns this mesh's gobal store UID
	 ------------------------------------------------------*/

	void RemoveFromPool();
	/*------------------------------------------------------
	 * Pre  :  
	 * Post : Remove this mesh from gobal store 
	 *        Does not delete mesh ( obviously )
	 ------------------------------------------------------*/


	
	static Vector<Mesh *> mGobalPool; /* Storage for gobal access */


};


